--[[

	SizeUpGizmo: Enhanced combat UI
		copyright 2005 by Chester
		(with code blatently stolen from my friend LOD)
	
	Updated by Detritis
	fixed and updated 2007 by CrowGoblin
]]

SIZEUP_VERSION = GetAddOnMetadata('CombatGizmo', 'Version');

INCOMBAT_COMBATFEEDBACK_FADEINTIME = 0.4;
INCOMBAT_COMBATFEEDBACK_HOLDTIME = 1.0;
INCOMBAT_COMBATFEEDBACK_FADEOUTTIME = 0.3;
--SIZEUP_MAINFRAME_START_ALPHA = 0.9;
SIZEUP_MAINFRAME_FADEOUTTIME = 2;
SIZEUP_MAINFRAME_FADEINTIME = 1;
NUM_DYNAMIC_ACTIONBUTTONS = 10;
NUM_DYNAMIC_STATICBUTTONS = 10;

SIZEUP_MAX_CHARACTER_LEVEL = 70;

SIZEUP_PARENTFRAME_WIDTH = 340;

MIN_ACTION_DURATION_TO_BE_INCOMBAT = 10.0;

COMBATFEEDBACK_FONT_HEIGHT = 40;

ManaTextColor = {};
ManaTextColor[0] = { r = 0.50, g = 0.50, b = 1.00, prefix = TEXT(MANA) };
ManaTextColor[1] = { r = 1.00, g = 0.00, b = 0.00, prefix = TEXT(RAGE_POINTS) };
ManaTextColor[2] = { r = 1.00, g = 0.50, b = 0.25, prefix = TEXT(FOCUS_POINTS) };
ManaTextColor[3] = { r = 1.00, g = 1.00, b = 0.00, prefix = TEXT(ENERGY_POINTS) };
ManaTextColor[4] = { r = 0.00, g = 1.00, b = 1.00, prefix = TEXT(HAPPINESS_POINTS) };

UnitReactionColor = {
	{ r = 1.0, g = 0.0, b = 0.0 },
	{ r = 1.0, g = 0.0, b = 0.0 },
	{ r = 1.0, g = 0.5, b = 0.0 },
	{ r = 1.0, g = 1.0, b = 0.0 },
	{ r = 0.0, g = 1.0, b = 0.0 },
	{ r = 0.0, g = 1.0, b = 0.0 },
	{ r = 0.0, g = 1.0, b = 0.0 },
};

local playermana;
local targetmana;

local titleGold = "|CFF00FF00";
local titleBlue = "|CFFFFFF00";
local loadingTitle = titleGold.. "SizeUpGizmo [" ..titleBlue..SIZEUP_VERSION..titleGold.. "] successfully loaded.";

PARTYDPS_TIME =	20;
PARTYDPS_UPDATERATE = 1;
SUG_MAX_COMBO_POINTS = 5;

-- Frame animation stuff
ANIMATEFRAME = {};

----------------------------------------------------------------------------------------------------------
-- Register SizeUpGizmo for myAddons.																	--
----------------------------------------------------------------------------------------------------------
SizeUpGizmo_Details = {
	name = "SizeUpGizmo",
	description = "This AddOn is a Player Vs Target comparison plus combat UI.",
	version = SIZEUP_VERSION,
	releaseDate = "September 24, 2005",
	author = "Chester",
	category = MYADDONS_CATEGORY_COMBAT,
	optionsframe = "SUGOptionsFrame"
};

--#region myAddons Help info
SizeUpGizmo_Help = {};
SizeUpGizmo_Help[1] = 	"|CFF00FF00Shortcuts for SizeUpGizmo.|r\n"..
						"|CFF99CCFF/sug lock - |CFFFFFFFFtoggle frame's locked state.\n"..
						"|CFF99CCFF/sug reset - |CFFFFFFFFreset the frame to the center of your screen.\n"..
						"|CFF99CCFF/sug alpha |CFFFFFF00< number > - |CFFFFFFFFchange the alpha of the SUG frame (ex: |CFF99CCFF/sug alpha 0.75).\n"..
						"|CFF99CCFF/sug scale |CFFFFFF00< number > - |CFFFFFFFFchange the scale of the SUG frame (ex: |CFF99CCFF/sug scale 0.80).\n"..
						"|CFF99CCFF/sug slidertoggle - |CFFFFFFFFtoggle the visibility of the slider on and off.\n"..
						"|CFF99CCFF/sug playerhealthtext - |CFFFFFFFFtoggle how your health text is displayed.\n"..
						"|CFF99CCFF/sug playermanatext - |CFFFFFFFFtoggle how your mana text is displayed.\n"..
						"|CFF99CCFF/sug targethealthtext - |CFFFFFFFFtoggle how your target's health is displayed (to show actual numbers, you must have MobInfo2 installed and have data on your target).\n"..
						"|CFF99CCFF/sug playerbuffs - |CFFFFFFFFtoggle showing your buffs.|r";
SizeUpGizmo_Help[2] = 	"|CFF00FF00Shortcuts for SizeUpGizmo (cont).|r\n"..
						"|CFF99CCFF/sug playerdebuffs - |CFFFFFFFFtoggle showing your debuffs.\n"..
						"|CFF99CCFF/sug targetbuffs - |CFFFFFFFFtoggle showing your target's buffs (not normally visible to most players).\n"..
						"|CFF99CCFF/sug targetdebuffs - |CFFFFFFFFtoggle showing your target's debuffs.\n"..
						"|CFF99CCFF/sug enemyonly - |CFFFFFFFFSUG will only show when a non-friendly enemy is targeted when on.\n"..
						"|CFF99CCFF/sug newcalcs - |CFFFFFFFFtoggle between using the new calculation method or the origional method.\n"..
						"|CFF99CCFF/sug partymode - |CFFFFFFFFtoggle between using Party Mode calculations and Solo Mode calculations.|r";
--#endregion

function SUG_UIFrameFadeOut(frame, timeToFade, startAlpha, endAlpha, func, arg1)
	local fadeInfo = {};
	fadeInfo.mode = "OUT";
	fadeInfo.timeToFade = timeToFade;
	fadeInfo.startAlpha = startAlpha;
	fadeInfo.endAlpha = endAlpha;
	fadeInfo.finishedFunc = func;
	fadeInfo.finishedArg1 = arg1;
	UIFrameFade(frame, fadeInfo);
end

--[[
--------------------------------------------------------------------------------------------------
-- BASE FRAME
--------------------------------------------------------------------------------------------------
]]
function SizeUpGizmo_OnLoad()
	this:RegisterEvent("VARIABLES_LOADED");
	this:RegisterEvent("PLAYER_ENTER_COMBAT");
	this:RegisterEvent("PLAYER_LEAVE_COMBAT");
	this:RegisterEvent("PLAYER_REGEN_DISABLED");
	this:RegisterEvent("PLAYER_REGEN_ENABLED");
	this:RegisterEvent("PLAYER_TARGET_CHANGED");
	this:RegisterEvent("UNIT_AURA");
	this:RegisterForDrag("LeftButton");

	SLASH_SIZEUPGIZMO1 = "/sizeupgizmo";
	SLASH_SIZEUPGIZMO2 = "/sug";
	SlashCmdList["SIZEUPGIZMO"] = function(msg)
		SizeUpGizmo_SlashCommand(msg);
	end
	
	this.lastupdate = 0;
	
	-- Check if myAddOns is loaded
	if(myAddOnsFrame_Register) then
		-- Register the addon in myAddOns
		myAddOnsFrame_Register(SizeUpGizmo_Details, SizeUpGizmo_Help);
	end
end

function SizeUpGizmo_OnEvent(event)
	if( event == "VARIABLES_LOADED" ) then
		if( not InCombatState ) then
			InCombatState = { };

			InCombatState.inCombat = nil;
			InCombatState.onHateList = nil;
			InCombatState.wasInCombat = nil;
			InCombatState.damageDone = 0;
			InCombatState.battleStartedAt = nil;
		end
		if (not SUG) then
			SUG = { };
		end
		
		if (not RaidTargetIcon1 or RaidTargetIcon1 == nil) then
			RaidTargetIcon1 = 8;
		end
		if (not RaidTargetIcon2 or RaidTargetIcon2 == nil) then
			RaidTargetIcon2 = 7;
		end
		if (not RaidTargetIcon2 or RaidTargetIcon3 == nil) then
			RaidTargetIcon3 = 6;
		end
		
		if( not SizeUpGizmoConfig ) then
			DEFAULT_CHAT_FRAME:AddMessage("Loading default settings!");
			SizeUpGizmoConfig = { };

			--SizeUpGizmoConfig.framePos_Left = 170;
			--SizeUpGizmoConfig.framePos_Top = 306;
			SizeUpGizmoConfig.simple = false;
			SizeUpGizmoConfig.enable = true;
			SizeUpGizmoConfig.locked = false;
			SizeUpGizmoConfig.partymode = false;
			SizeUpGizmoConfig.newcalcs = true;
			SizeUpGizmoConfig.alpha = 0.9;
			SizeUpGizmoConfig.scale = 1.5;
			SizeUpGizmoConfig.hideslider = true;
			SizeUpGizmoConfig.enemyonly = false;
			SizeUpGizmoConfig.p_htext = 1;
			SizeUpGizmoConfig.p_mtext = 1;
			SizeUpGizmoConfig.t_htext = 1;
			SizeUpGizmoConfig.t_mtext = 1;
			SizeUpGizmoConfig.player_b = 1;
			SizeUpGizmoConfig.player_d = 1;
			SizeUpGizmoConfig.target_b = 1;
			SizeUpGizmoConfig.target_d = 1;
			SizeUpGizmoConfig.LevelAdjust = 0;
			
			SizeUpGizmoConfig.csgscale = 1.5;
			SizeUpGizmoConfig.sentry = true;
			SizeUpGizmoConfig.enemy = true;
			SizeUpGizmoConfig.creatures = true;
			SizeUpGizmoConfig.friend = true;
			SizeUpGizmoConfig.range = true;
			SizeUpGizmoConfig.anchor = true;
			SizeUpGizmoConfig.raid = true;
			SizeUpGizmoConfig.combat = false;
			SizeUpGizmoConfig.csgsimple = true;
		end
		if (SizeUpGizmoConfig.version ~= SIZEUP_VERSION) then
			--UIErrorsFrame:AddMessage("New version detected! SUG version "..SIZEUP_VERSION, 1.0 , 0.0, 0.0, 1.0);
			SUGOptions_Buttons(1);
			SUGOptions_Buttons(2);
			SizeUpGizmoConfig.version = SIZEUP_VERSION;
		end
		if (not SizeUpGizmoConfig.simple) then
			SizeUpGizmoConfig.simple = false;
		end
		if (not SizeUpGizmoConfig.enable) then
			SizeUpGizmoConfig.enable = true;
		end
		if (not SizeUpGizmoConfig.locked) then
			SizeUpGizmoConfig.locked = false;
		end
		if (not SizeUpGizmoConfig.alpha) then
			SizeUpGizmoConfig.alpha = 0.9;
		end
		if (not SizeUpGizmoConfig.scale) then
			SizeUpGizmoConfig.scale = 1.5;
		end
		if (not SizeUpGizmoConfig.hideslider) then
			SizeUpGizmoConfig.hideslider = true;
		end
		if (not SizeUpGizmoConfig.enemyonly) then
			SizeUpGizmoConfig.enemyonly = false;
		end
		if (not SizeUpGizmoConfig.partymode) then
			SizeUpGizmoConfig.partymode = false;
		end
		if (not SizeUpGizmoConfig.newcalcs) then
			SizeUpGizmoConfig.newcalcs = true;
		end
		if (not SizeUpGizmoConfig.p_htext) then
			SizeUpGizmoConfig.p_htext = 1;
			SizeUpGizmoConfig.p_mtext = 1;
			SizeUpGizmoConfig.t_htext = 1;
			SizeUpGizmoConfig.t_mtext = 1;
		end
		if (not SizeUpGizmoConfig.player_b) then
			SizeUpGizmoConfig.player_b = 1;
			SizeUpGizmoConfig.player_d = 1;
			SizeUpGizmoConfig.target_b = 1;
			SizeUpGizmoConfig.target_d = 1;
		end
		
		if (not SizeUpGizmoConfig.csgscale) then
			SizeUpGizmoConfig.csgscale = 1.5;
		end
		if (not SizeUpGizmoConfig.sentry) then
			SizeUpGizmoConfig.sentry = true;
		end
		if (not SizeUpGizmoConfig.creatures) then
			SizeUpGizmoConfig.creatures = true;
		end
		if (not SizeUpGizmoConfig.friends) then
			SizeUpGizmoConfig.friends = true;
		end
		if (not SizeUpGizmoConfig.range) then
			SizeUpGizmoConfig.range = true;
		end
		if (not SizeUpGizmoConfig.anchor) then
			SizeUpGizmoConfig.anchor = true;
		end
		if (not SizeUpGizmoConfig.raid) then
			SizeUpGizmoConfig.raid = true;
		end
		if (not SizeUpGizmoConfig.combat) then
			SizeUpGizmoConfig.combat = false;
		end
		if (not SizeUpGizmoConfig.csgsimple) then
			SizeUpGizmoConfig.csgsimple = true;
		end
		
		if (CSGiz.on == 1) then
			SizeUpGizmoConfig.sentry = true;
		else
			SizeUpGizmoConfig.sentry = false;
		end
		if (CSGiz.anchor == 1) then
			SizeUpGizmoConfig.anchor = true;
		else
			SizeUpGizmoConfig.anchor = false;
		end
		if (CSGiz.detect == 1) then
			SizeUpGizmoConfig.enemy = true;
		else
			SizeUpGizmoConfig.enemy = false;
		end
		if (CSGiz.creatures == 1) then
			SizeUpGizmoConfig.creatures = true;
		else
			SizeUpGizmoConfig.creatures = false;
		end
		if (CSGiz.infotarget == 1) then
			SizeUpGizmoConfig.friend = true;
		else
			SizeUpGizmoConfig.friend = false;
		end
		if (CSGiz.sug == 1) then
			SizeUpGizmoConfig.enable = true;
		else
			SizeUpGizmoConfig.enable = false;
		end
		
		if( DEFAULT_CHAT_FRAME ) then
			DEFAULT_CHAT_FRAME:AddMessage(loadingTitle);
		end
		SizeUpGizmo_BaseFrame_UpdateFrames();
		return;
	-- Entry / Exit
	elseif( event == "PLAYER_ENTER_COMBAT" ) then
		InCombatState.inCombat = 1;
		SizeUpGizmo_BaseFrame_UpdateFrames();
		return;
	elseif( event == "PLAYER_LEAVE_COMBAT" ) then
		InCombatState.inCombat = nil;
		SizeUpGizmo_BaseFrame_UpdateFrames();
		return;
	elseif( event == "PLAYER_REGEN_DISABLED" ) then
		InCombatState.onHateList = 1;
		SizeUpGizmo_BaseFrame_UpdateFrames();
		return;
	elseif( event == "PLAYER_REGEN_ENABLED" ) then
		InCombatState.onHateList = nil;
		SizeUpGizmo_BaseFrame_UpdateFrames();
		return;
	elseif( event == "PLAYER_TARGET_CHANGED" ) then
		if ( UnitExists( "target" ) ) then
			SizeUpGizmo_UnitFrame_UpdateHealth( SizeUpGizmo_TargetFrame, "target" );
			SizeUpGizmo_UnitFrame_UpdateMana( SizeUpGizmo_TargetFrame, "target" );
			if (not UnitIsFriend("target", "player")) then
				SUG_TargetDPS.ttl = nil;	
			end	
		end
		SizeUpGizmo_BaseFrame_UpdateFrames();
		--SUG_TargetDPS = {};
		return;
	elseif ( event == "UNIT_AURA" ) then
		if (arg1 == "player") then
			SizeUpGizmo_Buffs_Update( "player" );
		elseif (arg1 == "target") then
			SizeUpGizmo_Buffs_Update( "target" );
		end
		return;
	end
end

function SizeUpGizmo_BaseFrame_UpdateFrames()
	--if not enabled then dont do anything and close the frame if it was already opened.
	if ( SizeUpGizmoConfig.enable == false ) then
		SizeUpGizmo_ParentHide();
		return;
	end
	
	if ( SizeUpGizmoConfig.enemyonly == true and UnitIsFriend("player", "target") ) then
		return;
	end
	SizeUpGizmo_ParentMasterFrame:SetWidth(SIZEUP_PARENTFRAME_WIDTH);
	SizeUpGizmo_BaseFrame:SetPoint("TOPLEFT", "UIParent", "BOTTOMLEFT", SizeUpGizmoConfig.framePos_Left, SizeUpGizmoConfig.framePos_Top);
	
	if (UIFrameIsFading(SizeUpGizmo_ParentMasterFrame)) then
		UIFrameFadeRemoveFrame(SizeUpGizmo_ParentMasterFrame);
	end

	local alpha = (SizeUpGizmo_ParentMasterFrame:GetAlpha())
--	if SizeUpGizmo_ParentMasterFrame:IsVisible() then
--		SizeUpGizmo_ParentMasterFrame:Hide();
--	end

	if ( UnitExists( "target" ) ) then
--		DEFAULT_CHAT_FRAME:AddMessage("SHOWING FRAME");		
		SizeUpGizmo_ParentMasterFrame:Show();
		SizeUpGizmo_ParentMasterFrame:SetAlpha(SizeUpGizmoConfig.alpha);
		
		SizeUpGizmo_BattleSuccess_Happiness:SetTexCoord(0.1875, 0.375, 0, 0.359375);

		SizeUpGizmo_PlayerClass_BackdropFrame:Show();
		SizeUpGizmo_TargetClass_BackdropFrame:Show();
		
		if (  InCombatState and (InCombatState.inCombat or InCombatState.onHateList) ) then
			if ( SizeUpGizmoConfig.simple == true ) then
				InCombatState.wasInCombat = nil;
				SizeUpGizmo_BaseFrame_ClearActions();

				SizeUpGizmo_ParentMasterFrame:SetHeight(17);
				SizeUpGizmo_BattleSuccess_SliderGlowFrame:SetHeight(22);
				SizeUpGizmo_BattleSuccess_SliderGlow:SetHeight(24);			

				SizeUpGizmo_TargetLevel_Text:SetAlpha(1.0);
				SizeUpGizmo_TargetName_Text:SetAlpha(1.0);
				SizeUpGizmo_PlayerLevel_Text:SetAlpha(1.0);
				SizeUpGizmo_PlayerName_Text:SetAlpha(1.0);
			
				SizeUpGizmo_PlayerLevel_Text:Show();
				SizeUpGizmo_PlayerName_Text:Show();
				SizeUpGizmo_PlayerFrame:Hide();
				--SizeUpGizmo_ActionFrame:Hide();			
				SizeUpGizmo_TargetFrame:Hide();

				SizeUpGizmoConfig.framePos_Left = SizeUpGizmo_BaseFrame:GetLeft();
				SizeUpGizmoConfig.framePos_Top = SizeUpGizmo_BaseFrame:GetTop();
			else
				--Show the combat frame
				InCombatState.wasInCombat = 1;

				--SizeUpGizmo_ActionFrame:Show();

				InCombatState.battleStartedAt = GetTime();
			
				UIFrameFadeOut(SizeUpGizmo_ParentMasterFrame, 0.05, SizeUpGizmo_ParentMasterFrame:GetAlpha(), 0.1)
				UIFrameFadeIn(SizeUpGizmo_ParentMasterFrame, 0.1, SizeUpGizmo_ParentMasterFrame:GetAlpha(), SizeUpGizmoConfig.alpha)
				SizeUpGizmo_ParentMasterFrame:SetHeight(48);
				SizeUpGizmo_BattleSuccess_SliderGlowFrame:SetHeight(54);
				SizeUpGizmo_BattleSuccess_SliderGlow:SetHeight(74);

				SizeUpGizmo_PlayerFrame:Show();
				SizeUpGizmo_TargetFrame:Show();
			
				SizeUpGizmo_PlayerClass_BackdropFrame:Hide();
				SizeUpGizmo_TargetClass_BackdropFrame:Hide();

				SizeUpGizmo_TargetLevel_Text:SetAlpha(0.7);
				SizeUpGizmo_TargetName_Text:SetAlpha(0.7);
				SizeUpGizmo_PlayerLevel_Text:SetAlpha(0.7);
				SizeUpGizmo_PlayerName_Text:SetAlpha(0.7);

				SizeUpGizmoConfig.framePos_Left = SizeUpGizmo_BaseFrame:GetLeft();
				SizeUpGizmoConfig.framePos_Top = SizeUpGizmo_BaseFrame:GetTop();

				-- Hide the mana display if the target doesn't use it
				if ( UnitManaMax("target") <= 0 ) then
					SizeUpGizmo_TargetFrameManaBar:Hide();
					SizeUpGizmo_TargetMana_Backdrop:Hide();
					SizeUpGizmo_TargetMana_BackdropText:Hide();
				else
					SizeUpGizmo_TargetFrameManaBar:Show();
					SizeUpGizmo_TargetMana_Backdrop:Show();
					SizeUpGizmo_TargetMana_BackdropText:Show();
					SizeUpGizmo_TargetFrame_ManaText:SetTextHeight(14.0);
				end

				SizeUpGizmo_UnitFrame_UpdateHealth( SizeUpGizmo_TargetFrame, "target" );
				SizeUpGizmo_UnitFrame_UpdateMana( SizeUpGizmo_TargetFrame, "target" );
				SizeUpGizmo_UnitFrameHealthBar_Update(SizeUpGizmo_PlayerFrameHealthBar, "player");
				SizeUpGizmo_UnitFrameHealthBar_Update(SizeUpGizmo_TargetFrameHealthBar, "target");
				SizeUpGizmo_UnitFrameHealthBackdrop_Update(SizeUpGizmo_PlayerHealth_Backdrop, "player");
				SizeUpGizmo_UnitFrameHealthBackdrop_Update(SizeUpGizmo_TargetHealth_Backdrop, "target");
				if (not UnitIsFriend("target", "player")) then
					SUG_TargetDPS.ttl = nil;	
				end
			end
		elseif ( UnitHealth("target") == 0 ) then
			SizeUpGizmo_ParentMasterFrame:Hide();
		else
			InCombatState.wasInCombat = nil;
			SizeUpGizmo_BaseFrame_ClearActions();

			SizeUpGizmo_ParentMasterFrame:SetHeight(17);
			SizeUpGizmo_BattleSuccess_SliderGlowFrame:SetHeight(22);
			SizeUpGizmo_BattleSuccess_SliderGlow:SetHeight(24);			

			SizeUpGizmo_TargetLevel_Text:SetAlpha(1.0);
			SizeUpGizmo_TargetName_Text:SetAlpha(1.0);
			SizeUpGizmo_PlayerLevel_Text:SetAlpha(1.0);
			SizeUpGizmo_PlayerName_Text:SetAlpha(1.0);
			
			SizeUpGizmo_PlayerLevel_Text:Show();
			SizeUpGizmo_PlayerName_Text:Show();
			SizeUpGizmo_PlayerFrame:Hide();
			--SizeUpGizmo_ActionFrame:Hide();			
			SizeUpGizmo_TargetFrame:Hide();

			SizeUpGizmoConfig.framePos_Left = SizeUpGizmo_BaseFrame:GetLeft();
			SizeUpGizmoConfig.framePos_Top = SizeUpGizmo_BaseFrame:GetTop();
		end
		if (SizeUpGizmoConfig.scale) then
			SizeUpGizmo_ParentMasterFrame:SetScale(0.1);
			SizeUpGizmo_ParentMasterFrame:SetScale(0.6666667 * SizeUpGizmoConfig.scale);	
		end
	elseif ( not SizeUpGizmo_ParentMasterFrame:IsVisible()) then
		return;

	else
--		DEFAULT_CHAT_FRAME:AddMessage("HIDING FRAME");

		SUG_UIFrameFadeOut(SizeUpGizmo_ParentMasterFrame, SIZEUP_MAINFRAME_FADEOUTTIME, alpha, 0, SizeUpGizmo_ParentHide)
	end
	SizeUpGizmo_Buffs_Initialize( "player" );
	SizeUpGizmo_Buffs_Initialize( "target" );
	SizeUpGizmo_Buffs_Update( "player" );
	SizeUpGizmo_Buffs_Update( "target" );

end

function SizeUpGizmo_OnUpdate()
	if (InCombatState and (InCombatState.inCombat or InCombatState.onHateList)) then
		if (not this.battleupdatetime) then
			this.battleupdatetime = GetTime() - 1.3;	
		end
		if ( (GetTime() - this.battleupdatetime) > 1.2 ) then
			this.battleupdatetime = GetTime();
			SizeUpGizmo_BattleSuccess_Update(1);
		end
	end
end

function SizeUpGizmo_ParentHide()
	SizeUpGizmo_ParentMasterFrame:Hide();
end

function SizeUpGizmo_SlashCommand(msg)
	--#region Help Messages.
	if( not msg or msg == "" ) then
		DEFAULT_CHAT_FRAME:AddMessage("|cff20ff20SizeUp Gizmo Commands:");
		DEFAULT_CHAT_FRAME:AddMessage("|cff20ff20/sug lock |CFF99CCFF- toggle frame's locked state");
		DEFAULT_CHAT_FRAME:AddMessage("|cff20ff20/sug reset |CFF99CCFF- reset the frame to the center of your screen");
		DEFAULT_CHAT_FRAME:AddMessage("|cff20ff20/sug alpha [number] |CFF99CCFF- change the alpha of the SUG frame (ex: /sug alpha 0.75)");
		DEFAULT_CHAT_FRAME:AddMessage("|cff20ff20/sug scale [number] |CFF99CCFF- change the scale of the SUG frame (ex: /sug scale 0.8)");
		DEFAULT_CHAT_FRAME:AddMessage("|cff20ff20/sug slidertoggle |CFF99CCFF- toggle the visibility of the slider on and off");
		DEFAULT_CHAT_FRAME:AddMessage("|cff20ff20/sug playerhealthtext |CFF99CCFF- toggle how your health text is displayed");
		DEFAULT_CHAT_FRAME:AddMessage("|cff20ff20/sug playermanatext |CFF99CCFF- toggle how your mana text is displayed");
		DEFAULT_CHAT_FRAME:AddMessage("|cff20ff20/sug targethealthtext |CFF99CCFF- toggle how your target's health is displayed (to show actual numbers, you must have MobHealth2 installed and have data on your target)");
		DEFAULT_CHAT_FRAME:AddMessage("|cff20ff20/sug targetmanatext |CFF99CCFF- toggle how your target's mana text is displayed");
		DEFAULT_CHAT_FRAME:AddMessage("|cff20ff20/sug playerbuffs |CFF99CCFF- toggle showing your buffs");
		DEFAULT_CHAT_FRAME:AddMessage("|cff20ff20/sug playerdebuffs |CFF99CCFF- toggle showing your debuffs");
		DEFAULT_CHAT_FRAME:AddMessage("|cff20ff20/sug targetbuffs |CFF99CCFF- toggle showing your target's buffs (not normally visible to most players)");
		DEFAULT_CHAT_FRAME:AddMessage("|cff20ff20/sug targetdebuffs |CFF99CCFF- toggle showing your target's debuffs");
		DEFAULT_CHAT_FRAME:AddMessage("|cff20ff20/sug enemyonly |CFF99CCFF- SUG will only show when a non-friendly enemy is targeted when on");
		DEFAULT_CHAT_FRAME:AddMessage("|cff20ff20/sug newcalcs |CFF99CCFF- toggle between using the new calculation method or the origional method");
		DEFAULT_CHAT_FRAME:AddMessage("|cff20ff20/sug partymode |CFF99CCFF- toggle between using Party Mode calculations and Solo Mode calculations");
	end
	--#endregion
	--#region Buttions.
	if( msg == "toggle" ) then
		if ( SizeUpGizmoConfig.enable ) then
			SizeUpGizmoConfig.enable = false;
		else
			SizeUpGizmoConfig.enable = true;
		end
	end
	if( msg == "simple" ) then
		if ( SizeUpGizmoConfig.simple ) then
			SizeUpGizmoConfig.simple = false;
		else
			SizeUpGizmoConfig.simple = true;
		end
	end
	if( msg == "options" ) then
		SUGOptions_Buttons(1);
	end
	if( msg == "reset" ) then
		SUGOptions_Buttons(2);
	end
	--#endregion
	--#region Toggle Buttons.
	if( msg == "slidertoggle" ) then
		SUGOptions_Toggle(1);
	end
	if( msg == "partymode" ) then
		SUGOptions_Toggle(2);
	end
	if( msg == "lock" ) then
		SUGOptions_Toggle(3);
	end
	if( msg == "enemyonly" ) then
		SUGOptions_Toggle(4);
	end
	if( msg == "newcalcs" ) then
		SUGOptions_Toggle(5);
	end
	if( msg == "playerbuffs" ) then
		SUGOptions_Toggle(6);
		return;
	end
	if( msg == "playerdebuffs" ) then
		SUGOptions_Toggle(7);
		return;
	end
	if( msg == "targetbuffs" ) then
		SUGOptions_Toggle(8);
		return;
	end
	if( msg == "targetdebuffs" ) then
		SUGOptions_Toggle(9);
		return;
	end
	--#endregion
	--#region Slider Bars.
	if (string.find(msg, "alpha") ~= nil) then
		local num;
		for num in string.gfind(msg, "alpha%s(%d+.*)") do
			if (tonumber(num) > 1) then
				num = 1;
			elseif (tonumber(num) < 0.1) then
				num = 0.1;
			end
			SizeUpGizmoConfig.alpha = tonumber(num);
			SizeUpGizmo_BaseFrame_UpdateFrames();
			DEFAULT_CHAT_FRAME:AddMessage("|cff20ff20SUG: Frame's alpha set to: "..num);
			--CSG_CaptureAttack(UnitName("target"), targetName, tonumber(damage), "target", 1);
			return;
		end
		if (not num) then
			DEFAULT_CHAT_FRAME:AddMessage("|cff20ff20SUG: Please specify a number between 0.1 and 1 (ex: /sug alpha 0.75)");			
		end
		return;
	end
	if (string.find(msg, "scale") ~= nil) then
		for scale in string.gfind(msg, "scale%s(%d.*)") do
			SUG.s = tonumber(scale);
		end
		if (SUG.s) then
			if (SUG.s > 2) then
				SUG.s = 2;
			elseif (SUG.s < 0.25) then
				SUG.s = 0.25;
			end
			SizeUpGizmo_ParentMasterFrame:SetScale(UIParent:GetScale() * SUG.s);
			SizeUpGizmoConfig.scale = (0.6666667 * SUG.s);
			DEFAULT_CHAT_FRAME:AddMessage("|cff20ff20SUG: SUG frame scale now set to: "..SUG.s);
		else
			DEFAULT_CHAT_FRAME:AddMessage("|cff20ff20SUG: Please type a scale number after 'scale' (valid numbers: 0.25 - 2, ex: /sug scale 0.8)");
		end
		return;
	end
	
	--#endregion
	--#region DropDown Menus.
	if( msg == "playerhealthtext" ) then
		if (SizeUpGizmoConfig.p_htext and SizeUpGizmoConfig.p_htext == "actual") then
			SizeUpGizmoConfig.p_htext = "percent";
			DEFAULT_CHAT_FRAME:AddMessage("|cff20ff20SUG: Player health now shown in percents.");
		elseif (SizeUpGizmoConfig.p_htext and SizeUpGizmoConfig.p_htext == "percent") then
			SizeUpGizmoConfig.p_htext = "max";
			DEFAULT_CHAT_FRAME:AddMessage("|cff20ff20SUG: Player health now showing actual health with max.");
		else
			SizeUpGizmoConfig.p_htext = "actual";
			DEFAULT_CHAT_FRAME:AddMessage("|cff20ff20SUG: Player health now showing actual health.");
		end
		SizeUpGizmo_UnitFrame_OnLoad( "player", SizeUpGizmo_PlayerHitIndicator, SizeUpGizmo_PlayerFrame_HealthText, SizeUpGizmo_PlayerFrame_ManaText, SizeUpGizmo_PlayerFrameManaBar );
		SizeUpGizmo_UnitFrame_UpdateHealth( SizeUpGizmo_PlayerFrame, "player" );
		return;
	end
	if( msg == "playermanatext" ) then
		if (SizeUpGizmoConfig.p_mtext and SizeUpGizmoConfig.p_mtext == "actual") then
			SizeUpGizmoConfig.p_mtext = "percent";
			DEFAULT_CHAT_FRAME:AddMessage("|cff20ff20SUG: Player mana now shown in percents.");
		elseif (SizeUpGizmoConfig.p_mtext and SizeUpGizmoConfig.p_mtext == "percent") then
			SizeUpGizmoConfig.p_mtext = "max";
			DEFAULT_CHAT_FRAME:AddMessage("|cff20ff20SUG: Player mana now showing actual mana with max.");
		else
			SizeUpGizmoConfig.p_mtext = "actual";
			DEFAULT_CHAT_FRAME:AddMessage("|cff20ff20SUG: Player mana now showing actual mana.");
		end
		SizeUpGizmo_UnitFrame_OnLoad( "player", SizeUpGizmo_PlayerHitIndicator, SizeUpGizmo_PlayerFrame_HealthText, SizeUpGizmo_PlayerFrame_ManaText, SizeUpGizmo_PlayerFrameManaBar );
		SizeUpGizmo_UnitFrame_UpdateMana( SizeUpGizmo_PlayerFrame, "player" );
		return;
	end
	if( msg == "targethealthtext" ) then
		if (SizeUpGizmoConfig.t_htext and SizeUpGizmoConfig.t_htext == "actual") then
			SizeUpGizmoConfig.t_htext = "percent";
			DEFAULT_CHAT_FRAME:AddMessage("|cff20ff20SUG: Target health now shown in percents.");
		elseif (SizeUpGizmoConfig.t_htext and SizeUpGizmoConfig.t_htext == "percent") then
			SizeUpGizmoConfig.t_htext = "max";
			DEFAULT_CHAT_FRAME:AddMessage("|cff20ff20SUG: Target health now showing actual health with max.");
		else
			SizeUpGizmoConfig.t_htext = "actual";
			DEFAULT_CHAT_FRAME:AddMessage("|cff20ff20SUG: Target health now showing actual health.");
		end
		if (UnitExists( "target" )) then
			SizeUpGizmo_UnitFrame_OnLoad( "target", SizeUpGizmo_TargetHitIndicator, SizeUpGizmo_TargetFrame_HealthText, SizeUpGizmo_TargetFrame_ManaText, SizeUpGizmo_TargetFrameManaBar );
			SizeUpGizmo_UnitFrame_UpdateHealth( SizeUpGizmo_TargetFrame, "target" );
		end
		return;
	end
	if( msg == "targetmanatext" ) then
		if (SizeUpGizmoConfig.t_mtext and SizeUpGizmoConfig.t_mtext == "actual") then
			SizeUpGizmoConfig.t_mtext = "percent";
			DEFAULT_CHAT_FRAME:AddMessage("|cff20ff20SUG: Target mana now shown in percents.");
		elseif (SizeUpGizmoConfig.t_mtext and SizeUpGizmoConfig.t_mtext == "percent") then
			SizeUpGizmoConfig.t_mtext = "max";
			DEFAULT_CHAT_FRAME:AddMessage("|cff20ff20SUG: Target mana now showing actual mana with max.");
		else
			SizeUpGizmoConfig.t_mtext = "actual";
			DEFAULT_CHAT_FRAME:AddMessage("|cff20ff20SUG: Target mana now showing actual mana.");
		end
		SizeUpGizmo_UnitFrame_OnLoad( "target", SizeUpGizmo_TargetHitIndicator, SizeUpGizmo_TargetFrame_HealthText, SizeUpGizmo_TargetFrame_ManaText, SizeUpGizmo_TargetFrameManaBar );
		SizeUpGizmo_UnitFrame_UpdateMana( SizeUpGizmo_TargetFrame, "target" );
		return;
	end
	--#endregion
end

function SizeUpGizmo_BaseFrame_ClearActions()
	InCombatState.battleStartedAt = nil;
end

--[[
-------------------------
-- SAVE FRAME POSITION
-------------------------
-- this function is called when the frame should be dragged around
]]
function SizeUpGizmo_OnMouseDown(arg1)
	if (arg1 == "LeftButton") then
		if (SizeUpGizmoConfig.locked == true) then
			return;
		else
			SizeUpGizmo_BaseFrame:StartMoving();
		end
	end
end

--[[
-- this function is called when the frame is stopped being dragged around
]]
function SizeUpGizmo_OnMouseUp(arg1)
	if (arg1 == "LeftButton") then
		SizeUpGizmo_BaseFrame:StopMovingOrSizing();
		-- save the position 
		SizeUpGizmoConfig.framePos_Left = SizeUpGizmo_BaseFrame:GetLeft();
		SizeUpGizmoConfig.framePos_Top = SizeUpGizmo_BaseFrame:GetTop();
	end

		-- DEFAULT_CHAT_FRAME:AddMessage("SAVING FRAME");
end

--[[
--------------------------------------------------------------------------------------------------
-- PLAYER FRAME
--------------------------------------------------------------------------------------------------
-- Event handlers
--------------------------------------------------------------------------------------------------
]]
function SizeUpGizmo_UnitFrame_OnLoad( unit, hitIndicator, healthtext, manatext, manabar )
	this.unit = unit;
	this.healthtext = healthtext;
	this.manatext = manatext;
	this.manabar = manabar;
	this.feedbackText = hitIndicator;
	this.feedbackFontHeight = COMBATFEEDBACK_FONT_HEIGHT;

	this:RegisterEvent("UNIT_COMBAT");
	this:RegisterEvent("UNIT_SPELLMISS");
	this:RegisterEvent("UNIT_HEALTH");
	this:RegisterEvent("UNIT_MAXHEALTH");
	this:RegisterEvent("UNIT_MANA");
	this:RegisterEvent("UNIT_RAGE");
	this:RegisterEvent("UNIT_FOCUS");
	this:RegisterEvent("UNIT_ENERGY");
	this:RegisterEvent("UNIT_HAPPINESS");
	this:RegisterEvent("UNIT_MAXMANA");
	this:RegisterEvent("UNIT_MAXRAGE");
	this:RegisterEvent("UNIT_MAXFOCUS");
	this:RegisterEvent("UNIT_MAXENERGY");
	this:RegisterEvent("UNIT_MAXHAPPINESS");
	this:RegisterEvent("UNIT_DISPLAYPOWER");
	this:RegisterEvent("UPDATE_SHAPESHIFT_FORMS");
end

function SizeUpGizmo_UnitFrame_OnEvent(event)
	if ( event == "UNIT_COMBAT" ) then
		-- Ignore events when we're out of combat
		if ( not SizeUpGizmo_TargetFrame:IsVisible() ) then
			return;
		end
		return;
	elseif ( event == "UNIT_HEALTH" or event == "UNIT_MAXHEALTH" ) then
		if ( arg1 == this.unit ) then
			SizeUpGizmo_UnitFrame_UpdateHealth( this, arg1 );
		end
		return;
	elseif ( event == "UNIT_MANA" or event == "UNIT_RAGE" or event == "UNIT_FOCUS" or event == "UNIT_ENERGY" or event == "UNIT_HAPPINESS" or event == "UNIT_MAXMANA" or event == "UNIT_MAXRAGE" or event == "UNIT_MAXFOCUS" or event == "UNIT_MAXENERGY" or event == "UNIT_MAXHAPPINESS" or event == "UNIT_DISPLAYPOWER" or event == "UPDATE_SHAPESHIFT_FORMS") then
		if ( arg1 == this.unit ) then
			SizeUpGizmo_UnitFrame_UpdateMana( this, arg1 );
		end
		return;
	end
end

function SizeUpGizmo_UnitFrame_UpdateHealth( frame, unit )
	local health = UnitHealth(unit);
	local percent = tonumber(format("%.0f", ( ( health / UnitHealthMax(unit) ) * 100 ) ) );

	if ( unit == "player" ) then
		if (SizeUpGizmoConfig.p_htext and SizeUpGizmoConfig.p_htext == 4) then
			frame.healthtext:SetText( percent.." %" );
		elseif (SizeUpGizmoConfig.p_htext and SizeUpGizmoConfig.p_htext == 3) then
			frame.healthtext:SetText( health );
		elseif (SizeUpGizmoConfig.p_htext and SizeUpGizmoConfig.p_htext == 2) then
			frame.healthtext:SetText( health.." / " .. UnitHealthMax(unit) );
		else
			frame.healthtext:SetText( health.." / " .. UnitHealthMax(unit) .." ("..format("%.0f", ( percent ) ).." %)" );
		end	
	else
		if ( UnitInParty(unit) or UnitInRaid(unit) ) then
			if ( SizeUpGizmoConfig.t_htext and SizeUpGizmoConfig.t_htext == 4) then
				frame.healthtext:SetText( percent.." %" );
			elseif ( SizeUpGizmoConfig.t_htext and SizeUpGizmoConfig.t_htext == 3) then
				frame.healthtext:SetText( health );
			elseif ( SizeUpGizmoConfig.t_htext and SizeUpGizmoConfig.t_htext == 2) then
				frame.healthtext:SetText( health.." / " .. UnitHealthMax(unit) );
			else
				frame.healthtext:SetText( health.." / " .. UnitHealthMax(unit) .." ("..format("%.0f", ( percent ) ).." %)" );
			end	
		else
			local mobHealth = 0;
			local mobHealthMax = 0; 
			
			if ( MobHealth3 ) then
				mobHealth, mobHealthMax = MobHealth3:GetUnitHealth(unit);
				--DEFAULT_CHAT_FRAME:AddMessage("MobHealth3 "..mobHealth.." / "..mobHealthMax);
			elseif ( MobHealthDB and MobHealth_GetTargetCurHP() ) then
				mobHealth = MobHealth_GetTargetCurHP();
				--DEFAULT_CHAT_FRAME:AddMessage("MobInfo "..mobHealth);
			end
			
			if ( SizeUpGizmoConfig.t_htext and SizeUpGizmoConfig.t_htext == 4) then
				frame.healthtext:SetText( percent.." %" );
			elseif ( SizeUpGizmoConfig.t_htext and SizeUpGizmoConfig.t_htext == 3) then
				frame.healthtext:SetText( mobHealth );
			elseif ( SizeUpGizmoConfig.t_htext and SizeUpGizmoConfig.t_htext == 2) then
				frame.healthtext:SetText( mobHealth.." / " .. mobHealthMax );
			else
				frame.healthtext:SetText( mobHealth.." / " .. mobHealthMax .." ("..format("%.0f", ( percent ) ).." %)" );
			end	
		end
	--[[if (SizeUpGizmoConfig.t_htext and SizeUpGizmoConfig.t_htext == 4) then
			if (UnitInParty(unit)) then
				frame.healthtext:SetText( percent.." %" );
			else
				frame.healthtext:SetText( health.." %" );
			end
		else
			if (MobHealthDB and MobHealth_GetTargetCurHP()) then
				--if (SizeUpGizmoConfig.t_htext and SizeUpGizmoConfig.t_htext == 1) then
				--	frame.healthtext:SetText( MobHealth_GetTargetCurHP().." / "..MobHealth_GetTargetMaxHP() );
				--else
				--	frame.healthtext:SetText( MobHealth_GetTargetCurHP() );
				--end
				if ( MobHealth3 ) then
                    if (SizeUpGizmoConfig.t_htext and SizeUpGizmoConfig.t_htext == 3) then
                        frame.healthtext:SetText( MobHealth3:GetUnitHealth( unit ) );
                    elseif (SizeUpGizmoConfig.t_htext and SizeUpGizmoConfig.t_htext == 2) then
						frame.healthtext:SetText( MobHealth3:GetUnitHealth( unit ) .." / " .. UnitHealthMax(unit) );
					else
						frame.healthtext:SetText( MobHealth3:GetUnitHealth( unit ) .." / " .. UnitHealthMax(unit) .." ("..percent.." %)" );
					end
				else
					if (SizeUpGizmoConfig.t_htext and SizeUpGizmoConfig.t_htext == 2) then
						frame.healthtext:SetText( MobHealth_GetTargetCurHP().." / "..MobHealth_GetTargetMaxHP() );
					else
						frame.healthtext:SetText( MobHealth_GetTargetCurHP() );
					end
				end
			else
				if (UnitInParty(unit)) then
					if (SizeUpGizmoConfig.t_htext and SizeUpGizmoConfig.t_htext == 2) then
						frame.healthtext:SetText( UnitHealth(unit).." / "..UnitHealthMax(unit) );
					else
						frame.healthtext:SetText( UnitHealth(unit) );
					end
				else
					frame.healthtext:SetText( health.." %" );
				end
			end
		end	]]
	end

	local color = SizeUpGizmo_GetColorForPercent( percent );
	frame.healthtext:SetTextColor( color.r, color.g, color.b );
end

function SizeUpGizmo_UnitFrameHealthBar_Update(statusbar, unit)
	if ( unit == statusbar.unit ) then
		local percent = (UnitHealth(unit) / UnitHealthMax(unit)) * 100;

		if ((percent <= 100) and (percent > 75)) then
			statusbar:SetStatusBarColor(0, 1, 0.2);
		elseif ((percent <= 75) and (percent > 50)) then
			statusbar:SetStatusBarColor(0.1, 1, 0.2);
		elseif ((percent <= 50) and (percent > 25)) then
			statusbar:SetStatusBarColor(0.3, 1, 0.3);
		else
			statusbar:SetStatusBarColor(0.5, 1, 0.4);
		end
	end

	UnitFrameHealthBar_Update(statusbar, unit);
end

function SizeUpGizmo_UnitFrameHealthBackdrop_Update(backdrop, unit)
	if ( unit == backdrop.unit ) then
		local percent = (UnitHealth(unit) / UnitHealthMax(unit)) * 100;

		if ((percent <= 100) and (percent > 75)) then
			backdrop:SetBackdropColor(0, 1, 0);
			backdrop:SetBackdropBorderColor(0, 1, 0);
			--Model_RotateLeft(SizeUpGizmo_BattleSuccess_MiniArrow, 1);
		elseif ((percent <= 75) and (percent > 50)) then
			backdrop:SetBackdropColor(1, 1, 0);
			backdrop:SetBackdropBorderColor(1, 1, 0);
		elseif ((percent <= 50) and (percent > 25)) then
			backdrop:SetBackdropColor(1, 0.5, 0);
			backdrop:SetBackdropBorderColor(1, 0.5, 0);
		else
			backdrop:SetBackdropColor(1, 0, 0);
			backdrop:SetBackdropBorderColor(1, 0, 0);
		end
	end
end						

function SizeUpGizmo_UnitFrame_UpdateMana( frame, unit )
	if (not unit) then
		return;
	end
	if (not frame.manatext) then
		return;
	end
	if (not frame.manatext:IsVisible()) then
		return;
	end

	local percent = (UnitMana(unit) / UnitManaMax(unit)) * 100;
	local manatype = UnitPowerType(unit);
	local info = ManaTextColor[manatype];
	frame.manatext:SetTextColor(info.r, info.g, info.b);
	if ( unit == "player" ) then
		if (SizeUpGizmoConfig.p_mtext and SizeUpGizmoConfig.p_mtext == 4) then
			frame.manatext:SetText( format("%.0f", ( percent ) ).." %" );
        elseif (SizeUpGizmoConfig.p_mtext and SizeUpGizmoConfig.p_mtext == 3) then
			frame.manatext:SetText( UnitMana(unit) );
		elseif (SizeUpGizmoConfig.p_mtext and SizeUpGizmoConfig.p_mtext == 2) then
			frame.manatext:SetText( UnitMana(unit).." / "..UnitManaMax(unit) );
		else
			frame.manatext:SetText( UnitMana(unit).." / "..UnitManaMax(unit).." ("..format("%.0f", ( percent ) ).." %)" );
		end	
	else	
		if (SizeUpGizmoConfig.t_mtext and SizeUpGizmoConfig.t_mtext == 4) then
			frame.manatext:SetText( format("%.0f", ( percent ) ).." %" );
		elseif (SizeUpGizmoConfig.t_mtext and SizeUpGizmoConfig.t_mtext == 3) then
			frame.manatext:SetText( UnitMana(unit) );
		elseif (SizeUpGizmoConfig.t_mtext and SizeUpGizmoConfig.t_mtext == 2) then
			frame.manatext:SetText( UnitMana(unit).." / "..UnitManaMax(unit) );
        else
			frame.manatext:SetText( UnitMana(unit).." / "..UnitManaMax(unit).." ("..format("%.0f", ( percent ) ).." %)" );
		end
	end

	info = ManaBarColor[manatype];
	frame.manabar:SetStatusBarColor(info.r, info.g, info.b);
	UnitFrameManaBar_Update(frame.manabar, unit);
end

function SizeUpGizmo_GetColorForPercent( percent )
	local color = { };
	color.r = 0;
	color.g = 0;
	color.b = 0;

	if ((percent <= 100) and (percent > 75)) then
		color.g = 1;
	elseif ((percent <= 75) and (percent > 50)) then
		color.r = 1;
		color.g = 1;
	elseif ((percent <= 50) and (percent > 25)) then
		color.r = 1;
		color.g = 0.5;
	else
		color.r = 1;
	end

	return color;
end 

--[[
-----------------------------------------------------------------------------------------------------------------
-- GET/SHOW BUFFS
-----------------------------------------------------------------------------------------------------------------
]]
function SizeUpGizmo_Buffs_Initialize( unit )
	local frame, bframe;
	for i = 1, 16 do
		frame = "SUG"..unit.."BuffFrame";
		bframe = getglobal(frame.."B"..i);
		bframe:Hide();
	end
	for i = 1, 16 do
		frame = "SUG"..unit.."DeBuffFrame";
		dframe = getglobal(frame.."D"..i);
		dframe:Hide();
	end
end

function SizeUpGizmo_Buffs_Update( unit )
	if (not unit) then
		SizeUpGizmo_Buffs_Initialize("player");
		SizeUpGizmo_Buffs_Initialize("target");
		return;	
	end
	local debuff, buff, frame, bframe;
	for i = 1, 16 do
		frame = "SUG"..unit.."BuffFrame";
		if (not SizeUpGizmoConfig[unit.."_b"] or SizeUpGizmoConfig[unit.."_b"] == 0) then
			getglobal("SUG"..unit.."BuffFrame"):Hide();
			break;
		else
			getglobal("SUG"..unit.."BuffFrame"):Show();
		end
        _,_, buff = UnitBuff(unit, i);

        bframe = getglobal(frame.."B"..i);
		if ( buff ) then
            getglobal(frame.."B"..i.."Icon"):SetTexture(buff);
			
            bframe:Show();
			bframe.id = i;				
		else
			bframe:Hide();
		end
	end
	for i=1, 16 do
		frame = "SUG"..unit.."DeBuffFrame";
		if (not SizeUpGizmoConfig[unit.."_d"] or SizeUpGizmoConfig[unit.."_d"] == 0) then
			getglobal("SUG"..unit.."DeBuffFrame"):Hide();
			break;
		else
			getglobal("SUG"..unit.."DeBuffFrame"):Show();
		end
		
		debuff, _, debuffTexture, debuffApplications = UnitDebuff(unit, i);

		dframe = getglobal(frame.."D"..i);
		if ( debuff ) then
			getglobal(frame.."D"..i.."Icon"):SetTexture(debuffTexture);
			debuffCount = getglobal(frame.."D"..i.."Count");
			if ( debuffApplications > 1 ) then
				debuffCount:SetText(debuffApplications);
				debuffCount:Show();
			else
				debuffCount:Hide();
			end
			dframe:Show();
		else
			dframe:Hide();
		end
		dframe.id = i;
	end
end

--[[
--------------------------------------------------------------------------------------------------
-- COMBO POINTS
--------------------------------------------------------------------------------------------------
]]
function SizeUpGizmo_ComboPointsFrame_OnEvent()
	local comboPoints = GetComboPoints();
	local comboPoint, comboPointHighlight, fadeInfo;
	if ( comboPoints > 0 ) then
		if ( not SizeUpGizmo_ComboFrame:IsVisible() ) then
			SizeUpGizmo_ComboFrame:Show();
		end
		
		for i=1, SUG_MAX_COMBO_POINTS do
			comboPoint = getglobal("SizeUpGizmo_ComboPoint"..i);
			comboPointHighlight = getglobal("SizeUpGizmo_ComboPoint"..i.."Highlight");
			comboPointShine = getglobal("SizeUpGizmo_ComboPoint"..i.."Shine");

			if ( i <= comboPoints ) then
				if ( comboPointHighlight:GetAlpha() == 0 or comboPoints == SUG_MAX_COMBO_POINTS) then
					--PlaySound("MapPing")

					comboPoint:SetAlpha(1);

					-- Fade in the highlight and set a function that triggers when it is done fading
					fadeInfo = {};
					fadeInfo.mode = "IN";
					fadeInfo.timeToFade = COMBOFRAME_HIGHLIGHT_FADE_IN;
					fadeInfo.finishedFunc = SizeUpGizmo_ComboPointShineFadeIn;
					fadeInfo.finishedArg1 = comboPointShine;
					UIFrameFade(comboPointHighlight, fadeInfo);
				end
			else
				comboPoint:SetAlpha(0);
				comboPointHighlight:SetAlpha(0);
				comboPointShine:SetAlpha(0);
			end
		end
	else
		SizeUpGizmo_ComboFrame:Hide();
	end
end

function SizeUpGizmo_ComboPointShineFadeIn(frame)
	-- Fade in the shine and then fade it out with the SizeUpGizmo_ComboPointShineFadeOut function
	local fadeInfo = {};
	fadeInfo.mode = "IN";
	fadeInfo.timeToFade = COMBOFRAME_SHINE_FADE_IN;
	fadeInfo.finishedFunc = SizeUpGizmo_ComboPointShineFadeOut;
	fadeInfo.finishedArg1 = frame:GetName();
	UIFrameFade(frame, fadeInfo);
end

--[[
--hack since a frame can't have a reference to itself in it
]]
function SizeUpGizmo_ComboPointShineFadeOut(frameName)
	UIFrameFadeOut(getglobal(frameName), COMBOFRAME_SHINE_FADE_OUT);
end

--[[
--------------------------------------------------------------------------------------------------
-- BATTLE SUCCESS
--------------------------------------------------------------------------------------------------
--UNIT_PVP_UPDATE 
--UnitIsPVP("unit") 
]]
function SizeUpGizmo_BattleSuccess_OnLoad(arg1)
	
	this.cursliderpos = 0;

	this:RegisterEvent("PARTY_MEMBERS_CHANGED");
	this:RegisterEvent("PLAYER_ENTER_COMBAT");
	this:RegisterEvent("PLAYER_LEAVE_COMBAT");
	this:RegisterEvent("PLAYER_REGEN_DISABLED");
	this:RegisterEvent("PLAYER_REGEN_ENABLED");
	this:RegisterEvent("PLAYER_TARGET_CHANGED");
	this:RegisterEvent("UNIT_COMBAT");
	this:RegisterEvent("UNIT_HEALTH");
	this:RegisterEvent("UNIT_MAXHEALTH");
	this:RegisterEvent("UNIT_MANA");
	this:RegisterEvent("UNIT_RAGE");
	this:RegisterEvent("UNIT_FOCUS");
	this:RegisterEvent("UNIT_ENERGY");
	this:RegisterEvent("UNIT_HAPPINESS");
	this:RegisterEvent("UNIT_MAXMANA");
	this:RegisterEvent("UNIT_MAXRAGE");
	this:RegisterEvent("UNIT_MAXFOCUS");
	this:RegisterEvent("UNIT_MAXENERGY");
	this:RegisterEvent("UNIT_MAXHAPPINESS");
	this:RegisterEvent("UNIT_DISPLAYPOWER");
	this:RegisterEvent("UPDATE_SHAPESHIFT_FORMS");
end

function SizeUpGizmo_BattleSuccess_OnEvent(event)
	this.playerhealth = (UnitHealth("player") / UnitHealthMax("player")) * 100;
	this.targethealth = (UnitHealth("target") / UnitHealthMax("target")) * 100;
	this.playerLevel = UnitLevel("player");
	this.targetLevel = UnitLevel("target");
	if ( this.targetLevel == -1 ) then
		this.targetLevel = SIZEUP_MAX_CHARACTER_LEVEL;
		--DEFAULT_CHAT_FRAME:AddMessage("Target Level: "..this.targetLevel);
	end

	if (	
		event == "PARTY_MEMBERS_CHANGED" or
		event == "PLAYER_ENTER_COMBAT" or 
		event == "PLAYER_LEAVE_COMBAT" or 
		event == "PLAYER_REGEN_DISABLED" or 
		event == "PLAYER_REGEN_ENABLED" or 
		event == "PLAYER_TARGET_CHANGED" or 

		event == "UNIT_COMBAT" or 
		event == "UNIT_HEALTH" or 
		event == "UNIT_MAXHEALTH" or 
		event == "UNIT_MANA" or 
		event == "UNIT_RAGE" or 
		event == "UNIT_FOCUS" or 
		event == "UNIT_ENERGY" or 
		event == "UNIT_HAPPINESS" or 
		event == "UNIT_MAXMANA" or 
		event == "UNIT_MAXRAGE" or 
		event == "UNIT_MAXFOCUS" or 
		event == "UNIT_MAXENERGY" or 
		event == "UNIT_MAXHAPPINESS" or 
		event == "UNIT_DISPLAYPOWER" or 
		event == "UPDATE_SHAPESHIFT_FORMS") then
		
		-- Ignore events when the frame is hidden
		if ( not SizeUpGizmo_ParentMasterFrame:IsVisible() ) then
			return;
		end		
		SizeUpGizmo_BattleSuccess_Update();
		SizeUpGizmo_BattleSuccess_SliderThumbBottom:SetTexCoord(0, 1, 1, 0);	
--		DEFAULT_CHAT_FRAME:AddMessage("this.cursliderpos: "..this.cursliderpos);		
	end
end

function SizeUpGizmo_BattleSuccess_Update(force)
	if (not force and InCombatState and (InCombatState.inCombat == 1 or InCombatState.onHateList == 1)) then
		return;
	end
	if ( not UnitExists( "target" ) ) then
		return;
	end
	
	--#Region Original calculations
	if ( SizeUpGizmoConfig.newcalcs == false ) then
		SizeUpGizmoConfig.partymode = false;
		SUGOptionsFrameToggleButton2:SetChecked(SizeUpGizmoConfig.partymode);
		this.levelAdjust = (this.playerLevel - this.targetLevel);
		
		local numPartyMembers = GetNumPartyMembers(); 
	
		if ( UnitClassification("target") == "worldboss" ) then
			this.levelAdjust = ((this.levelAdjust - 25) * 5);
		elseif ( UnitIsPlusMob("target") ) then
			if ((this.levelAdjust >= -5) and (this.levelAdjust <= 5)) then
				this.levelAdjust = ((this.levelAdjust - 5) * 5);
			else
				this.levelAdjust = ((this.levelAdjust - 10) * 5);		
			end
		else
			if ((this.levelAdjust >= -3) and (this.levelAdjust <= 3)) then
				this.levelAdjust = (this.levelAdjust * 2);
			else
				this.levelAdjust = (this.levelAdjust * 5);		
			end
		end
	
		if ( UnitPowerType("player") == 1 or 3 ) then
			local playermana = (UnitMana("player") / UnitManaMax("player")) * 100;
			if ( playermana <= 40 ) then
				this.levelAdjust = (this.levelAdjust + (playermana - 40));
			end
		end
	
		if ( UnitPowerType("target") == 1 or 3 ) then
			local targetmana = (UnitMana("target") / UnitManaMax("target")) * 100;
			if ( targetmana <= 40 ) then
				this.levelAdjust = (this.levelAdjust + (45 - targetmana));
			end
		end
	
		if (not force and SUG_TargetDPS.ttl and SUG_TargetDPS.ttl < 80 ) then
			if (not PlayerDPS.ttl) then
				PlayerDPS.ttl = 240;	
			end
			this.relative = (((PlayerDPS.ttl * 2) - (SUG_TargetDPS.ttl * 2)) + ((this.playerhealth - this.targethealth) + this.levelAdjust)) / 2; 
			--ChatFrame3:AddMessage("["..PlayerDPS.ttl.."]  VS  ["..SUG_TargetDPS.ttl.."]");
		else	
			this.relative = ((this.playerhealth - this.targethealth) + this.levelAdjust);
		end
	--#Endregion
	--#Region New Calculations
	else	
		this.levelAdjust = ( this.playerLevel - this.targetLevel ) - SizeUpGizmoConfig.LevelAdjust;
		this.partyLevelAverage = 0;
		this.groupPartyLevel = 0;
		
		if ( GetNumPartyMembers() > 0 and SizeUpGizmoConfig.partymode == true ) then
			if ( UnitInRaid( "party1" ) == 1 ) then
				this.numPartyMembers = GetNumRaidMembers() - 1;
			else
				this.numPartyMembers = GetNumPartyMembers();
			end
			
			if ( UnitExists( "party1" ) ~= nil ) then
				this.groupPartyLevel = UnitLevel( "party1" );
				--DEFAULT_CHAT_FRAME:AddMessage("Party1: " ..this.groupPartyLevel);
			end
			if ( UnitExists( "party2" ) ~= nil ) then
				this.groupPartyLevel = this.groupPartyLevel + UnitLevel( "party2" );
				--DEFAULT_CHAT_FRAME:AddMessage("Party2: " ..this.groupPartyLevel);
			end
			if ( UnitExists( "party3" ) ~= nil ) then
				this.groupPartyLevel = this.groupPartyLevel + UnitLevel( "party3" );
				--DEFAULT_CHAT_FRAME:AddMessage("Party3: " ..this.groupPartyLevel);
			end
			if ( UnitExists( "party4" ) ~= nil ) then
				this.groupPartyLevel = this.groupPartyLevel + UnitLevel( "party4" );
				--DEFAULT_CHAT_FRAME:AddMessage("Party4: " ..this.groupPartyLevel);
			end
				
			this.partyLevelAverage = this.groupPartyLevel / this.numPartyMembers;
		elseif ( GetNumPartyMembers() > 0 and SizeUpGizmoConfig.partymode == false ) then
			this.numPartyMembers = 0;
			this.partyLevelAverage = 0;
		else
			this.numPartyMembers = 0;
			this.partyLevelAverage = 0;
		end
		--[[ Working on the assumption that as you level, mobs at the same level as you become slighty 
		more difficult then mobs that were the same level as you, when you were lower leveled :P
		ie. at level 10 a mob at level 10 is x% hard to kill but at level 20 a mob at level 20 will be 
		x% + .x difficult to kill (well I know what I mean anyway)
		]]
		if ( UnitClassification("target") == "worldboss" ) then
			this.worldBossLevel = 60;
			this.worldBossPenalty = 37;
			this.difficultyMultiplier = 1;
			this.levelAdjust = ( this.playerLevel - this.worldBossLevel );
			
			this.levelAdjust = (this.levelAdjust - this.worldBossPenalty) * -1;
		elseif ( UnitClassification("target") == "rareelite" ) then
			this.rareElitePenalty = 8 + ( this.playerLevel / ( SIZEUP_MAX_CHARACTER_LEVEL / 1.5 ) );
			this.difficultyMultiplier = 2.5 - ( this.targetLevel - this.partyLevelAverage);
			
			this.levelAdjust = (this.levelAdjust - this.rareElitePenalty) * -1;
		elseif ( UnitClassification("target") == "elite" ) then
			this.elitePenalty = 4 + ( this.playerLevel / SIZEUP_MAX_CHARACTER_LEVEL );
			this.difficultyMultiplier = 2.5 - ( this.targetLevel - this.partyLevelAverage);
			
			this.levelAdjust = (this.levelAdjust - this.elitePenalty) * -1;
		elseif ( UnitClassification("target") == "rare" ) then
			this.rarePenalty = 2 + ( this.playerLevel / ( SIZEUP_MAX_CHARACTER_LEVEL * 2 ) );
			this.difficultyMultiplier = 2.5 - ( this.targetLevel - this.partyLevelAverage);
			
			this.levelAdjust = (this.levelAdjust - this.rarePenalty) * -1;
		elseif ( UnitClassification("target") == "normal" ) then
			this.normalPenalty = 0;
			this.difficultyMultiplier = 5 - ( this.targetLevel - this.partyLevelAverage);
			
			this.levelAdjust = (this.levelAdjust - this.normalPenalty) * -1;
		end
		
		this.levelAdjust = ( this.difficultyMultiplier * this.numPartyMembers ) - this.levelAdjust;
		
		if ( UnitPowerType("player") == 0 ) then
			this.playerMana = ( UnitMana("player") / UnitManaMax("player") ) * 100;
			this.playerManaMax = 100;
		else
			this.playerMana = 0;
			this.playerManaMax = 0;
		end
		
		if ( UnitPowerType("target") == 0 ) then
			this.targetMana = ( UnitMana("target") / UnitManaMax("target") ) * 100;
			this.targetManaMax = 100;
		else
			this.targetMana = 0;
			this.targetManaMax = 0;
		end
		
		this.levelAdjust = ( ( ( this.playerMana - this.playerManaMax ) / 10 ) + ( this.levelAdjust * 2 ) ) / 2;
		this.levelAdjust = this.levelAdjust + ( ( this.targetManaMax - this.targetMana) / 10 ) / 2;
		
		if (not force and SUG_TargetDPS.ttl and SUG_TargetDPS.ttl < 80 ) then
			if (not PlayerDPS.ttl) then
				PlayerDPS.ttl = 240;	
			end
			this.relative = ( this.levelAdjust + ( ( ( PlayerDPS.ttl ) - ( SUG_TargetDPS.ttl ) + ( this.playerhealth - this.targethealth ) ) / 9.5 ) ) / 1;
		else	
			this.relative = ( ( ( this.playerhealth - this.targethealth ) / 9.5 ) + this.levelAdjust ) / 1;
		end
	end
	--#Endregion
	-- caps the slider end positions so they dont go off the parent frame
	if (this.cursliderpos < -( SIZEUP_PARENTFRAME_WIDTH / 2.06 )) then
		this.cursliderpos = -( SIZEUP_PARENTFRAME_WIDTH / 2.06 );
	elseif (this.cursliderpos > ( SIZEUP_PARENTFRAME_WIDTH / 2.06 )) then
		this.cursliderpos = ( SIZEUP_PARENTFRAME_WIDTH / 2.06 );
	end

	--[[ The numbers for how the battle is going	
	(75 / 100)  (1.0, 0.0, 0.0)
	(82 / 100)  (1.0, 0.25, 0.0)
	(90 / 100)  (1.0, 0.75, 0.0)
	(96 / 100)  (1.0, 1.0, 0.1)
	(100 / 100) (1.0, 1.0, 1.0)
	(100 / 96)  (1.0, 1.0, 0.1)s
	(100 / 90)  (0.75, 1.0, 0.0)
	(100 / 82)  (0.25, 1.0, 0.0)
	(100 / 75)  (0.0, 1.0, 0.0)
	]]
	
	if ( SizeUpGizmoConfig.newcalcs == false ) then
		--#region Old Calculations
		if ( this.relative <= -40 ) then													-- Death
			SizeUpGizmo_BattleSuccess_Starburst:SetVertexColor(1.0, 0.0, 0.0);
			SizeUpGizmo_BattleSuccess_Happiness:SetTexCoord(0.375, 0.5625, 0, 0.359375);
		elseif ( this.relative > -40 ) and ( this.relative <= -25 ) then					-- Very Hard
			SizeUpGizmo_BattleSuccess_Starburst:SetVertexColor(1.0, 0.25, 0.0);
			SizeUpGizmo_BattleSuccess_Happiness:SetTexCoord(0.375, 0.5625, 0, 0.359375);
		elseif ( this.relative > -25 ) and ( this.relative <= -15 ) then					-- Hard
			SizeUpGizmo_BattleSuccess_Starburst:SetVertexColor(1.0, 0.75, 0.0);
			SizeUpGizmo_BattleSuccess_Happiness:SetTexCoord(0.375, 0.5625, 0, 0.359375);
		elseif ( this.relative > -15 ) and ( this.relative <= -5 ) then						-- Normal
			SizeUpGizmo_BattleSuccess_Starburst:SetVertexColor(1.0, 1.0, 0.1);
			SizeUpGizmo_BattleSuccess_Happiness:SetTexCoord(0.375, 0.5625, 0, 0.359375);
	----
		elseif ( this.relative >= 10 ) and ( this.relative < 20 ) then						-- Normal
			SizeUpGizmo_BattleSuccess_Starburst:SetVertexColor(1.0, 1.0, 0.1);
			SizeUpGizmo_BattleSuccess_Happiness:SetTexCoord(0, 0.1875, 0, 0.359375);
		elseif ( this.relative >= 20 ) and ( this.relative < 30 ) then						-- Hard
			SizeUpGizmo_BattleSuccess_Starburst:SetVertexColor(0.75, 1.0, 0);
			SizeUpGizmo_BattleSuccess_Happiness:SetTexCoord(0, 0.1875, 0, 0.359375);
		elseif ( this.relative >= 30 ) and ( this.relative < 40 ) then						-- Very Hard
			SizeUpGizmo_BattleSuccess_Starburst:SetVertexColor(0.25, 1.0, 0);
			SizeUpGizmo_BattleSuccess_Happiness:SetTexCoord(0, 0.1875, 0, 0.359375);
		elseif ( this.relative >= 40 ) then													-- Death
			SizeUpGizmo_BattleSuccess_Starburst:SetVertexColor(0.0, 1.0, 0.0);
			SizeUpGizmo_BattleSuccess_Happiness:SetTexCoord(0, 0.1875, 0, 0.359375);
		else																				-- Easy
			SizeUpGizmo_BattleSuccess_Starburst:SetVertexColor(1.0, 1.0, 1.0);
			SizeUpGizmo_BattleSuccess_StarburstBIG:SetAlpha(0);
			SizeUpGizmo_BattleSuccess_Happiness:SetTexCoord(0.1875, 0.375, 0, 0.359375);
		end
	
		if ( this.relative <= -40 ) then
			SizeUpGizmo_BattleSuccess_Death:SetAlpha(1.0);
			SizeUpGizmo_BattleSuccess_Happiness:SetAlpha(0.0);
		else
			SizeUpGizmo_BattleSuccess_Death:SetAlpha(0.0);
			SizeUpGizmo_BattleSuccess_Happiness:SetAlpha(1.0);
		end
	
		if (this.relative <= -35 ) then
			SizeUpGizmo_ParentMasterFrame:SetBackdropBorderColor(0.6, 0.1, 0.1);
			SizeUpGizmo_ParentMasterFrame:SetBackdropColor(0.3, 0.05, 0.05);
		elseif ( this.relative >= 35 ) then
			SizeUpGizmo_ParentMasterFrame:SetBackdropBorderColor(0.05, 0.2, 0.05);
			SizeUpGizmo_ParentMasterFrame:SetBackdropColor(0.05, 0.3, 0.05);
		else
			SizeUpGizmo_ParentMasterFrame:SetBackdropBorderColor(0.1, 0.1, 0.1);
			SizeUpGizmo_ParentMasterFrame:SetBackdropColor(0.29, 0.29, 0.39);
		end
		--#endregion
	else
		local baseRelative = math.floor(this.relative);
		if ( baseRelative <= -5 ) then
			SizeUpGizmo_BattleSuccess_Starburst:SetVertexColor(1.0, 0.0, 0.0);
			SizeUpGizmo_BattleSuccess_Happiness:SetTexCoord(0.375, 0.5625, 0, 0.359375);
		elseif ( baseRelative == -4  ) then
			SizeUpGizmo_BattleSuccess_Starburst:SetVertexColor(1.0, 0.25, 0.0);
			SizeUpGizmo_BattleSuccess_Happiness:SetTexCoord(0.375, 0.5625, 0, 0.359375);
		elseif ( baseRelative == -3 ) then
			SizeUpGizmo_BattleSuccess_Starburst:SetVertexColor(1.0, 0.75, 0.0);
			SizeUpGizmo_BattleSuccess_Happiness:SetTexCoord(0.375, 0.5625, 0, 0.359375);
		elseif ( baseRelative == -2 )  then
			SizeUpGizmo_BattleSuccess_Starburst:SetVertexColor(1.0, 1.0, 0.1);
			SizeUpGizmo_BattleSuccess_Happiness:SetTexCoord(0.1875, 0.375, 0, 0.359375);
	-- ----------------------------------------------------------------------------------
		elseif ( baseRelative == 2 ) then
			SizeUpGizmo_BattleSuccess_Starburst:SetVertexColor(1.0, 1.0, 0.1);
			SizeUpGizmo_BattleSuccess_Happiness:SetTexCoord(0.1875, 0.375, 0, 0.359375);
		elseif ( baseRelative == 3 ) then
			SizeUpGizmo_BattleSuccess_Starburst:SetVertexColor(0.75, 1.0, 0);
			SizeUpGizmo_BattleSuccess_Happiness:SetTexCoord(0, 0.1875, 0, 0.359375);
		elseif ( baseRelative == 4  ) then
			SizeUpGizmo_BattleSuccess_Starburst:SetVertexColor(0.25, 1.0, 0);
			SizeUpGizmo_BattleSuccess_Happiness:SetTexCoord(0, 0.1875, 0, 0.359375);
		elseif ( baseRelative >= 5 ) then
			SizeUpGizmo_BattleSuccess_Starburst:SetVertexColor(0.0, 1.0, 0.0);
			SizeUpGizmo_BattleSuccess_Happiness:SetTexCoord(0, 0.1875, 0, 0.359375);
		else
			SizeUpGizmo_BattleSuccess_Starburst:SetVertexColor(1.0, 1.0, 1.0);
			SizeUpGizmo_BattleSuccess_StarburstBIG:SetAlpha(0);
			SizeUpGizmo_BattleSuccess_Happiness:SetTexCoord(0.1875, 0.375, 0, 0.359375);
		end
	
		if ( baseRelative <= -5 or this.relative >= 5 ) then
			SizeUpGizmo_BattleSuccess_Death:SetAlpha(1.0);
			SizeUpGizmo_BattleSuccess_Happiness:SetAlpha(0.0);
		else
			SizeUpGizmo_BattleSuccess_Death:SetAlpha(0.0);
			SizeUpGizmo_BattleSuccess_Happiness:SetAlpha(1.0);
		end
	
		if ( baseRelative <= -3 ) then
			SizeUpGizmo_ParentMasterFrame:SetBackdropBorderColor(0.6, 0.1, 0.1);
			SizeUpGizmo_ParentMasterFrame:SetBackdropColor(0.3, 0.05, 0.05);
		elseif ( baseRelative == 2 ) then
			SizeUpGizmo_ParentMasterFrame:SetBackdropBorderColor(0.4, 0.4, 0);
			SizeUpGizmo_ParentMasterFrame:SetBackdropColor(0.6, 0.6, 0);
		elseif ( baseRelative == -2 ) then
			SizeUpGizmo_ParentMasterFrame:SetBackdropBorderColor(0.4, 0.4, 0);
			SizeUpGizmo_ParentMasterFrame:SetBackdropColor(0.6, 0.6, 0);
		elseif ( baseRelative >= 3 ) then
			SizeUpGizmo_ParentMasterFrame:SetBackdropBorderColor(0.05, 0.3, 0.05);
			SizeUpGizmo_ParentMasterFrame:SetBackdropColor(0.05, 0.4, 0.05);
		else
			SizeUpGizmo_ParentMasterFrame:SetBackdropBorderColor(0.1, 0.1, 0.1);
			SizeUpGizmo_ParentMasterFrame:SetBackdropColor(0.4, 0.4, 0.5);
		end
	end
	
	SizeUpGizmo_SliderUpdate();
end

function SizeUpGizmo_SliderUpdate()
	local endsliderpos = ((this.relative * 33.50) * -1)
	--caps the slider end positions so they dont go off the parent frame
	if (endsliderpos < -( SIZEUP_PARENTFRAME_WIDTH / 2.06 )) then
		endsliderpos = -(SIZEUP_PARENTFRAME_WIDTH / 2.06) ;
	elseif (endsliderpos > ( SIZEUP_PARENTFRAME_WIDTH / 2.06 )) then
		endsliderpos = (SIZEUP_PARENTFRAME_WIDTH / 2.06);
	end
	
--	if (SizeUpGizmo_AnimationIsAnimating(SizeUpGizmo_BattleSuccess_Slider)) then
--		SizeUpGizmo_BattleSuccess_Slider:SetPoint("BOTTOM", "SizeUpGizmo_ParentMasterFrame", "TOP", endsliderpos, -15);		
--		SizeUpGizmo_AnimationRemove(SizeUpGizmo_BattleSuccess_Slider);
--	end


--[[	
		0	= .5
		85	= .25
		170	= 0

		-170 = 0
		170 = 1
]]


--	DEFAULT_CHAT_FRAME:AddMessage("endsliderpos: "..endsliderpos);

	-- animates the slider to the left or right
	if (this.cursliderpos ~= endsliderpos) then
		if (this.cursliderpos > endsliderpos) then
			SizeUpGizmo_FrameAnimationDown(SizeUpGizmo_BattleSuccess_SliderGlowFrame, 0.8, (this.cursliderpos), endsliderpos);
		elseif (this.cursliderpos < endsliderpos) then
			SizeUpGizmo_FrameAnimationUp(SizeUpGizmo_BattleSuccess_SliderGlowFrame, 0.8, (this.cursliderpos), endsliderpos);
		else
			SizeUpGizmo_BattleSuccess_SliderGlowFrame:SetPoint("CENTER", "SizeUpGizmo_ParentMasterFrame", "CENTER", endsliderpos, 0);
		end
		
		this.cursliderpos = endsliderpos;
	end

	--	DEFAULT_CHAT_FRAME:AddMessage("endsliderpos: "..endsliderpos);

	--sets the backround glows for the slider (used to set the base trail glow also)
	local bgalpha = ( endsliderpos / ( SIZEUP_PARENTFRAME_WIDTH / 2 ) );
	if (bgalpha > 0.3) then
		bgalpha = (bgalpha - 0.3);
	elseif (bgalpha > 1) then
		bgalpha = 1;
	elseif (bgalpha < 0) then
		bgalpha = (bgalpha * -1);
	end
	
	--the thumb's glow is a bit softer
	local thumbglowalpha = (bgalpha)
	--caps the green end of the glow because it was really blown out
	if (thumbglowalpha < 0.3) then
		thumbglowalpha = 0.3;
	end

	local rcolor = ( (0.0029) * endsliderpos ) + 0.5 ;
	local gcolor = ( (-0.0029) * endsliderpos ) + 0.5 ;
	local thumbrcolor = rcolor 
	local thumbgcolor = gcolor 	
	if (thumbrcolor < 0.5) then
		thumbrcolor = 0.5
	end	
	if (thumbgcolor < 0.5) then
		thumbgcolor = 0.5
	end

	SizeUpGizmo_BattleSuccess_StarburstBIG:SetVertexColor(rcolor, gcolor, 0);
	SizeUpGizmo_BattleSuccess_StarburstBIG:SetAlpha(bgalpha);
	SizeUpGizmo_BattleSuccess_SliderGlow:SetVertexColor(rcolor, gcolor, 0);

end 

--[[
--------------------------------------------------------------------------------------------------
-- GENERIC ANIM FUNCTION
--------------------------------------------------------------------------------------------------
]]
function SizeUpGizmo_FrameAnimation(frame, animInfo)
	if ( not animInfo.mode ) then
		animInfo.mode = "UP";
	end
	local finalpos;
	if ( animInfo.mode == "UP" ) then
		if ( not animInfo.startAnimPos ) then
			animInfo.startAnimPos = -1;
		end
		if ( not animInfo.endAnimPos ) then
			animInfo.endAnimPos = 1;
		end
		finalpos = -1;
	elseif ( animInfo.mode == "DOWN" ) then
		if ( not animInfo.startAnimPos ) then
			animInfo.startAnimPos = 1;
		end
		if ( not animInfo.endAnimPos ) then
			animInfo.endAnimPos = -1;
		end
		finalpos = 1;
	end
	frame:SetPoint("CENTER", this:GetParent():GetName(), "CENTER", animInfo.startAnimPos, 0);


	frame.animInfo = animInfo;
	if ( frame ) then
		frame:Show();
		tinsert(ANIMATEFRAME, frame);
	end
end

--[[
-- Convenience function to do a simple animation in positive direction
-- (timeToAnim * SIZEUP_PARENTFRAME_WIDTH) hack is due to frame size
]]
function SizeUpGizmo_FrameAnimationUp(frame, timeToAnim, startAnimPos, endAnimPos)
	local animInfo = {};
	animInfo.mode = "UP";
	animInfo.startAnimPos = startAnimPos;
	animInfo.endAnimPos = endAnimPos;
--	local slidetime = 1;
--	if (animInfo.startAnimPos > animInfo.endAnimPos) then
--		local slidetime = (-0.0029) * endAnimPos;
--	elseif (animInfo.startAnimPos < animInfo.endAnimPos) then
--		local slidetime = (0.0029) * endAnimPos;
--	else
--		local slidetime = 1;
--	end
	animInfo.timeToAnim = timeToAnim;
	SizeUpGizmo_FrameAnimation(frame, animInfo);
end

--[[
-- Convenience function to do a simple animation in negative direction
-- (timeToAnim * SIZEUP_PARENTFRAME_WIDTH) hack is due to frame size
]]
function SizeUpGizmo_FrameAnimationDown(frame, timeToAnim, startAnimPos, endAnimPos)
	local animInfo = {};
	animInfo.mode = "DOWN";
	animInfo.timeToAnim = timeToAnim;
	animInfo.startAnimPos = startAnimPos;
	animInfo.endAnimPos = endAnimPos;
--	local slidetime = 1;
--	if (animInfo.startAnimPos > animInfo.endAnimPos) then
--		local slidetime = (-0.0029) * endAnimPos;
--	elseif (animInfo.startAnimPos < animInfo.endAnimPos) then
--		local slidetime = (0.0029) * endAnimPos;
--	else
--		local slidetime = 1;
--	end
	SizeUpGizmo_FrameAnimation(frame, animInfo);
end

--[[  ** Function that performs the animation movement
Fading frame attribute listing
============================================================
frame.timeToAnim  [Num]		Time it takes to animate the frame up or down
frame.mode  ["UP", "DOWN"]	Anim direction
 ]]
function SizeUpGizmo_AnimationUpdate(elapsed)
	local index = 1;
	local frame, animInfo;
	while ANIMATEFRAME[index] do
		frame = ANIMATEFRAME[index];
		animInfo = ANIMATEFRAME[index].animInfo;
		-- Reset the timer if there isn't one, this is just an internal counter
		if ( not animInfo.animTimer ) then
			animInfo.animTimer = 0;
		end
		animInfo.animTimer = animInfo.animTimer + elapsed;

		-- If the animTimer is less then the desired anim time then set the state
		if ( animInfo.animTimer < animInfo.timeToAnim ) then
			if ( animInfo.mode == "UP" ) then
				frame:SetPoint("CENTER", this:GetParent():GetName(), "CENTER", (animInfo.animTimer / animInfo.timeToAnim) * (animInfo.endAnimPos - animInfo.startAnimPos) + animInfo.startAnimPos, 0);
			elseif ( animInfo.mode == "DOWN" ) then
				frame:SetPoint("CENTER", this:GetParent():GetName(), "CENTER", ((animInfo.timeToAnim - animInfo.animTimer) / animInfo.timeToAnim) * (animInfo.startAnimPos - animInfo.endAnimPos) + animInfo.endAnimPos, 0);
			end
		else
			frame:SetPoint("CENTER", this:GetParent():GetName(), "CENTER", animInfo.endAnimPos, 0);
			SizeUpGizmo_AnimationRemove(frame);
--				DEFAULT_CHAT_FRAME:AddMessage("STOPPED");
			break;
		end			
		index = index + 1;
--		DEFAULT_CHAT_FRAME:AddMessage("animInfo.animTimer: "..animInfo.animTimer);
	end
end

function SizeUpGizmo_AnimationRemove(frame)
	tDeleteItem(ANIMATEFRAME, frame);
end

function SizeUpGizmo_AnimationIsAnimating(frame)
	for index, value in ANIMATEFRAME do
		if ( value == frame ) then
			return 1;
		end
	end
	return nil;
end

--[[
		PartyDPS: Shows the enemy DPS being done to party members, and expected Time To Live.
		copyright 2004 by LOD
		(Modified by Chester to work with SizeUpGizmo)
]]
function PartyMemberDPSTemplate_OnLoad()
	this:RegisterEvent("UNIT_COMBAT");
	this:RegisterEvent("UNIT_HEALTH");
	this:RegisterEvent("UNIT_MAXHEALTH");
		
	local frameName = this:GetName();
	this.text = getglobal( frameName.."Text" );
	this.text:SetText("DPS: 0");

	-- Data
	this.healthevents = {};
	this.prevhealth = nil;
	this.dps = 0;
	this.lastupdate = 0;

	-- SizeUpGizmo support.
	if ( this:GetID() == 0 ) then
		this:RegisterEvent("PLAYER_REGEN_ENABLED");
	end
end

function PartyMemberDPSTemplate_OnEvent()
	if ( event == "UNIT_COMBAT" or event == "UNIT_HEALTH" or event == "UNIT_MAXHEALTH" ) then
		local unit = "player";
		
		if ( this:GetID() == 1 ) then
			unit = "target";
		end
		
		if (not unit) then
			return;	
		end
		
		if ( this.prevhealth == nil ) then
			this.prevhealth = UnitHealth(unit);
		end

		if ( arg1 == unit ) then
			local dmg = this.prevhealth - UnitHealth(unit);
			--ChatFrame3:AddMessage(GREEN_FONT_COLOR_CODE.."------- UNIT = "..unit);

			if ( dmg > 0 ) then
--				getglobal("SizeUpGizmo_TargetDPS_TextFrame"):Show();
--				getglobal("SizeUpGizmo_PlayerTTL_TextFrame"):Show();
				this.text:Show();

				local temp = { };
				temp["time"] = GetTime();
				temp["damage"] = dmg;
				table.insert(this.healthevents, temp);

				--DEFAULT_CHAT_FRAME:AddMessage(dmg.." damage to party member "..UnitName(unit)..", time "..GetTime()..", health "..UnitHealth(unit));

				if (this.dps == nil) then
					this.dps = dmg;
				else
					this.dps = this.dps + dmg;
					--DEFAULT_CHAT_FRAME:AddMessage( UnitName(unit).." dps total: "..this.dps );
				end
			elseif ( dmg < 0 ) then
				--DEFAULT_CHAT_FRAME:AddMessage((dmg*-1).." healing to party member "..UnitName(unit)..", time "..GetTime()..", health "..UnitHealth(unit));
			end

			this.prevhealth = UnitHealth(unit);
		end

		return;
	end

	if ( event == "PLAYER_REGEN_ENABLED" ) then
		this.text:Hide();
		return;
	end
	
end

function PartyMemberDPSTemplate_OnUpdate()
	local unit = "player";
	
	if PlayerDPSText:IsVisible() then
		getglobal("SizeUpGizmo_PlayerLevel_Text"):Hide();		
	else
		getglobal("SizeUpGizmo_PlayerLevel_Text"):Show();		
	end
	
	if ( this:GetID() == 1 ) then
		unit = "target";
		this.text:Hide();
	end
	
	if (not unit) then
		return;	
	end
	
	if ( this.prevhealth == nil ) then
		this.prevhealth = UnitHealth(unit);
	end
	
	if (not this.ttl) then
		this.ttl = 999;	
	end

	local curtime = GetTime();
	local oldesttime = 0;
	local deleteindex = 0;

	if ( (curtime - this.lastupdate) > PARTYDPS_UPDATERATE ) then
		--ChatFrame3:AddMessage(GREEN_FONT_COLOR_CODE.."-------"..this:GetName());
		if ( (table.getn(this.healthevents) == 0 ) ) then
			this.text:Hide();
			getglobal("SizeUpGizmo_PlayerLevel_Text"):Show();
			return;
		end

		for i = 1, table.getn(this.healthevents), 1 do
			if ( (curtime - PARTYDPS_TIME) > this.healthevents[i].time ) then
				this.dps = this.dps - this.healthevents[i].damage;
				--DEFAULT_CHAT_FRAME:AddMessage( UnitName(unit).." dps total: "..this.dps );
				deleteindex = i;
			else
				oldesttime = this.healthevents[i].time;
				break;
			end
		end

		-- Remove entries from deleteindex down so we don't miss em
		while (deleteindex > 0) do
			--DEFAULT_CHAT_FRAME:AddMessage( curtime.." : Removed event for "..UnitName(unit)..". Damage "..this.healthevents[deleteindex].damage.." at time "..this.healthevents[deleteindex].time );
			table.remove(this.healthevents, deleteindex);
			deleteindex = deleteindex - 1;
		end
	
		if ( this.dps ~= nil ) then
			--DEFAULT_CHAT_FRAME:AddMessage( UnitName(unit).." DPSTOTAL: "..this.dps.." over time "..(curtime - oldesttime+1).." = "..(this.dps / (curtime - oldesttime+1) ) ); 
			local DPS = (this.dps / (curtime - oldesttime + 1));
			
			if ( DPS ) then
				this.ttl = UnitHealth(unit) / DPS;
				--ChatFrame3:AddMessage(GREEN_FONT_COLOR_CODE.."-------"..this:GetName().." TTL: "..this.ttl);
				local TTL = this.ttl;
				local timeunit = "sec";
				
				if ( TTL > 60 ) then
					TTL = TTL / 60;
					timeunit = "min";
					this.text:SetTextColor( 1.0, 1.0, 1.0 );
				elseif ( TTL < 15 ) then
					this.text:SetTextColor( 1.0, 0.0, 0.0 );
				elseif ( TTL < 30 ) then
					this.text:SetTextColor( 1.0, 1.0, 0.0 );
				end

				if ( this:GetID() == 0 ) then
					PlayerDPSText:SetText( format(TEXT("%.1fdps"), DPS ) );
					PlayerTTLText:SetText( format(TEXT("%.0f "..timeunit), TTL ) );
				else
					this.text:SetText( format(TEXT("%.2f dps \n%.0f "..timeunit), DPS, TTL ) );					
				end
			else
				this.text:SetText( format(TEXT("%.0f dps"), DPS ) );
			end
		end

		this.lastupdate = curtime;
	end

end

--[[
--------------------------------------------------------------------------------------------------
-- TARGET INFO
--------------------------------------------------------------------------------------------------
]]
function SizeUpGizmo_TargetInfo_OnLoad()
	this.statusCounter = 0;
	this.statusSign = -1;
	this.unitHPPercent = 1;
	SizeUpGizmo_TargetInfo_Update();
	this:RegisterEvent("UNIT_LEVEL");
	this:RegisterEvent("UNIT_FACTION");
	this:RegisterEvent("UNIT_DYNAMIC_FLAGS");
	this:RegisterEvent("UNIT_CLASSIFICATION_CHANGED");
	this:RegisterEvent("PLAYER_PVPLEVEL_CHANGED");
	this:RegisterEvent("PLAYER_TARGET_CHANGED");
	this:RegisterEvent("PARTY_MEMBERS_CHANGED");
	this:RegisterEvent("PARTY_LEADER_CHANGED");
	this:RegisterEvent("PARTY_MEMBER_ENABLE");
	this:RegisterEvent("PARTY_MEMBER_DISABLE");
	this:RegisterEvent("UNIT_AURA");
	this:RegisterEvent("PLAYER_FLAGS_CHANGED");
end

function SizeUpGizmo_TargetInfo_Update()
	if ( UnitExists("target") ) then
		SizeUpGizmo_TargetInfo_CheckLevel();
		SizeUpGizmo_TargetInfo_CheckFaction();
		SizeUpGizmo_TargetInfo_GetClass();
--		SizeUpGizmo_TargetInfo_CheckClassification();
--		SizeUpGizmo_TargetInfo_CheckDead();
--		TargetDebuffButton_Update();
	else
--		this:Hide();
	end
end

function SizeUpGizmo_TargetInfo_OnEvent(event)
	UnitFrame_OnEvent(event);

	if ( event == "UNIT_LEVEL" ) then
		if ( arg1 == "target" ) then
			SizeUpGizmo_TargetInfo_CheckLevel();
		end
		return;
	end
	if ( event == "UNIT_FACTION" ) then
		if ( arg1 == "target" or arg1 == "player" ) then
			SizeUpGizmo_TargetInfo_CheckFaction();
			SizeUpGizmo_TargetInfo_CheckLevel();
		end
		return;
	end
	if ( event == "UNIT_DYNAMIC_FLAGS" ) then
		if ( arg1 == "target" ) then
			SizeUpGizmo_TargetInfo_CheckFaction();
		end
		return;
	end
--[[	if ( event == "UNIT_CLASSIFICATION_CHANGED" ) then
		if ( arg1 == "target" ) then
			SizeUpGizmo_TargetInfo_CheckClassification();
		end
		return;
]]--	end
	if ( event == "PLAYER_TARGET_CHANGED" or event == "PARTY_MEMBERS_CHANGED" or event == "PARTY_LEADER_CHANGED" or event == "PARTY_MEMBER_ENABLE" or event == "PARTY_MEMBER_DISABLE") then
		SizeUpGizmo_TargetInfo_Update();
		if ( event == "PARTY_MEMBERS_CHANGED" ) then
			SizeUpGizmo_TargetInfo_CheckFaction();
		end
		return;
	end
--[[	if ( event == "UNIT_AURA" and arg1 == "target" ) then
		TargetDebuffButton_Update();
		return;
]]--	end
end

function SizeUpGizmo_TargetInfo_CheckLevel()
	local playerLevel = UnitLevel("player");
	local targetLevel = UnitLevel("target");
	SizeUpGizmo_PlayerLevel_Text:SetText(playerLevel);
	if ( UnitIsPlusMob("target") ) then
		SizeUpGizmo_TargetLevel_Text:SetText("+"..targetLevel);
	elseif (UnitClassification("target") == "worldboss" ) then
		SizeUpGizmo_TargetLevel_Text:SetText("??");
	elseif ( targetLevel == 0 ) then
		SizeUpGizmo_TargetLevel_Text:SetText("--");
	else
		SizeUpGizmo_TargetLevel_Text:SetText(targetLevel);
	end
	-- Color level number
	local color = GetDifficultyColor(targetLevel);
	SizeUpGizmo_TargetLevel_Text:SetVertexColor(color.r, color.g, color.b);
end

function SizeUpGizmo_TargetInfo_GetClass()
	local targetLevel = UnitLevel("target");
	if ( UnitPlayerControlled("target") ) then
		SizeUpGizmo_TargetClass_Text:SetText(UnitClass("target"));
	else
		SizeUpGizmo_TargetClass_Text:SetText(UnitCreatureType("target") );
	end
	SizeUpGizmo_PlayerClass_Text:SetText(UnitClass("player") );
	SizeUpGizmo_PlayerClass_Text:SetVertexColor(0.9, 0.9, 0.9);
	local color = GetDifficultyColor(targetLevel);
	SizeUpGizmo_TargetClass_Text:SetVertexColor(color.r, color.g, color.b);
	SizeUpGizmo_PlayerClass_Text:SetAlpha(0.7);
	SizeUpGizmo_TargetClass_Text:SetAlpha(0.7);
end

function SizeUpGizmo_TargetInfo_CheckFaction()
	local targetName = UnitName("target");
	local playerName = UnitName("player");
	SizeUpGizmo_TargetName_Text:SetText(targetName);
	SizeUpGizmo_PlayerName_Text:SetText(playerName);
	if ( UnitPlayerControlled("target") ) then
		local r, g, b;
		if ( UnitCanAttack("target", "player") ) then
			-- Hostile players are red
			if ( not UnitCanAttack("player", "target") ) then
				r = 0.0;
				g = 0.0;
				b = 1.0;
			else
				r = UnitReactionColor[2].r;
				g = UnitReactionColor[2].g;
				b = UnitReactionColor[2].b;
			end
		elseif ( UnitCanAttack("player", "target") ) then
			-- Players we can attack but which are not hostile are yellow
			r = UnitReactionColor[4].r;
			g = UnitReactionColor[4].g;
			b = UnitReactionColor[4].b;
		elseif ( UnitIsPVP("target") ) then
			-- Players we can assist but are PvP flagged are green
			r = UnitReactionColor[6].r;
			g = UnitReactionColor[6].g;
			b = UnitReactionColor[6].b;
		else
			-- All other players are blue (the usual state on the "blue" server)
			r = 0.4;
			g = 0.4;
			b = 1.0;
		end
		SizeUpGizmo_TargetName_Text:SetVertexColor(r, g, b);
--		TargetPortrait:SetVertexColor(1.0, 1.0, 1.0);
	elseif ( UnitIsTapped("target") and not UnitIsTappedByPlayer("target") ) then
		SizeUpGizmo_TargetName_Text:SetVertexColor(0.5, 0.5, 0.5);
		SizeUpGizmo_TargetName_Text:SetText(">>>"..targetName);
--		TargetPortrait:SetVertexColor(0.5, 0.5, 0.5);
	else
		local reaction = UnitReaction("target", "player");
		if ( reaction ) then
			local r, g, b;
			r = UnitReactionColor[reaction].r;
			g = UnitReactionColor[reaction].g;
			b = UnitReactionColor[reaction].b;
			SizeUpGizmo_TargetName_Text:SetVertexColor(r, g, b);
		else
			SizeUpGizmo_TargetName_Text:SetVertexColor(0, 0, 1.0);
		end
--		TargetPortrait:SetVertexColor(1.0, 1.0, 1.0);
	end
end
